unit Dotu;

interface
uses graphics;

type
TDot = class(Tobject)
private
xpos,ypos,direction,trailwidth : integer;
trailcolour : Tcolor;
showtrail : boolean;
gridsize: integer;

protected

public
  //signatures of all methods
  constructor Create;    overload;
  constructor create(x,y,w: integer;c: Tcolor);  overload;
  destructor Destroy; override;
  procedure move();
  procedure turnleft();
  procedure turnright();
  function getXPos():integer;
  function getYPos():integer;
  function getdirection():integer;      //1 UP,2 right 3 down 4 left
  procedure setposition(x,y: integer);
  procedure setdirection(d: integer);
  procedure settrailwidth(w: integer);
  procedure settrailcolor(c:TColor);
  procedure trailoff();
  procedure trailOn();
  procedure setgridsize(g: integer);


  published
end;


implementation
uses unit1;
{ TDot }

constructor TDot.Create;

begin
  inherited;

  xpos := 300;
  ypos := 300;
  direction := 1;
  form1.Canvas.MoveTo(xpos,ypos);
  trailwidth :=4;
  trailcolour := clred;
  showtrail := true;
  gridsize := 30;
  form1.canvas.Rectangle(xpos-2,ypos,xpos+2,ypos+4);

end;

destructor TDot.Destroy; 
begin
inherited;
end;

constructor TDot.Create(x, y, w: integer; c: Tcolor);
begin
xpos := x;
ypos:= y;
trailwidth:= w;
trailcolour := c;
gridsize:= 5;
showtrail := false;
form1.canvas.Rectangle(xpos-2,ypos,xpos+2,ypos+4);

end;

function TDot.getdirection: integer;
begin
getdirection := direction;
end;

function TDot.getXPos: integer;
begin
getXPos := xpos;
end;

function TDot.getYPos: integer;
begin
getypos := ypos;
end;

procedure TDot.move;
begin

form1.Canvas.Pen.Color := form1.Color;
form1.Canvas.Pen.Color := trailcolour;
form1.Canvas.Pen.Width := trailwidth;

case direction of
1: begin        //up
   ypos := ypos - gridsize;
   if showtrail = true then
   form1.canvas.lineto(xpos,ypos)
   else
   form1.canvas.moveto(xpos,ypos);
   form1.canvas.Rectangle(xpos-2,ypos,xpos+2,ypos+4);
   end;
2: begin         //left
   xpos := xpos -  gridsize;
   if showtrail = true then
   form1.canvas.lineto(xpos,ypos)
   else
   form1.canvas.moveto(xpos,ypos);
   form1.canvas.Rectangle(xpos,ypos-2,xpos+4,ypos+2);
   end;
3: begin         //down
   ypos := ypos +  gridsize;
   if showtrail = true then
   form1.canvas.lineto(xpos,ypos)
   else
   form1.canvas.moveto(xpos,ypos);
   form1.canvas.Rectangle(xpos-2,ypos,xpos+2,ypos+4);
   end;
4: begin         //right
   xpos := xpos +  gridsize;
   if showtrail = true then
   form1.canvas.lineto(xpos,ypos)
   else
   form1.canvas.moveto(xpos,ypos);
   form1.canvas.Rectangle(xpos-4,ypos-2,xpos,ypos+2);
   end;

   end;//case


end;

procedure TDot.setdirection(d: integer);
begin
direction := d;
end;

procedure TDot.setgridsize(g: integer);
begin
gridsize := g;
end;

procedure TDot.setposition(x, y: integer);
begin
form1.Canvas.MoveTo(x,y);
end;

procedure TDot.settrailcolor(c: TCOlor);
begin
trailcolour:=  c;
end;

procedure TDot.settrailwidth(w: integer);

begin
trailwidth := w
end;

procedure TDot.trailoff;
begin
showtrail := false;
end;

procedure TDot.trailOn;
begin
showtrail := true;
end;

procedure TDot.turnleft;
begin
inc(direction);
if direction = 5 then direction := 1;

end;

procedure TDot.turnright;
begin
dec(direction);
if direction = 0 then direction := 4;
end;

end.
